function S_hat = solve_12_norm(S, beta, d, m)

S_hat = zeros(d,m);
for index = 1 : m
    
    s = S(:, index);
    s_norm = norm(s);
    
    if (s_norm > beta / 2)
        S_hat(:, index) = s * (1 - beta / 2 / s_norm);
    end

end